/*
*
* Programma TOT
* Test di invio/ricezione di un semplice frame ethernet
*/

#include <sys.h>
#include <lib.h>

extern int semaforo_eth;
void pethsend(int a)
{
  char buff[1500];
  char* messaggio;
  int count, dim;
  int a_buf = 1500;

  sem_wait(semaforo_eth);
  printf(a, "Processo di prova invio\n");
  printf(a, "scrivi un messaggio:\n");
  
  term_read_n(a, buff, a_buf);
  for (dim=0; dim<1500; dim++){
	if (buff[dim] == 0) break;
  }

  printf(a, "dimensione del pacchetto: %d\n", dim);
  messaggio = (char*) mem_alloc(dim+14);  

  //costruisco il pacchetto sulla base dei dati inseriti

  messaggio[0] = 0xDC; //mac destinazione

  messaggio[1] = 0xFA;
  messaggio[2] = 0x11;
  messaggio[3] = 0x9A;
  messaggio[4] = 0xC3;
  messaggio[5] = 0x1A;

  messaggio[6] = 0xDC; //mac sorgente

  messaggio[7] = 0xFA;
  messaggio[8] = 0x11;
  messaggio[9] = 0x9A;
  messaggio[10] = 0xC3;
  messaggio[11] = 0x1B;

  //tipo del frame: TCP/IP

  messaggio[12] = 0x87;
  messaggio[13] = 0x6B; 

  //riempio il payload del pacchetto

  for (int i=0; i<dim; i++){
	messaggio[(14+i)]=buff[i];
  }

  //padding se il pacchetto  minore di 46byte

  if (dim<=46){
	for(int i=0; i<(64-dim);i++) messaggio[(14+dim)+i] = 0;
  }

  printf(a, "Invio in corso...\n");  

  //invio il pacchetto

  eth_dma_scrivi(0, messaggio, 78);
  printf(a, "Testo inviato: %s\n", messaggio);
  printf(a, "Invio completato\n");

	terminate_p();
}
